<?php

use WHMCS\View\Menu\Item as MenuItem;

function getEuroDNSConfig()
{
    require_once dirname(__FILE__).'/classEuroDNS.php';

    $result = select_query('tblregistrars', 'value', ['registrar' => 'EuroDNS', 'setting' => 'Username']);
    $data = mysql_fetch_assoc($result);
    $username = decrypt($data['value']);
    $result = select_query('tblregistrars', 'value', ['registrar' => 'EuroDNS', 'setting' => 'Password']);
    $data = mysql_fetch_assoc($result);
    $password = decrypt($data['value']);
    $result = select_query('tblregistrars', 'value', ['registrar' => 'EuroDNS', 'setting' => 'TestMode']);
    $data = mysql_fetch_assoc($result);
    $testMode = decrypt($data['value']);

    return [
        'Username' => $username,
        'Password' => $password,
        'TestMode' => $testMode,
    ];
}

function eurodns_ShoppingCartValidateDomainsConfig($vars)
{
    try {
        $attr = getEuroDNSConfig();
        $API = new EuroDNS($attr);

        foreach ($_SESSION['cart']['domains'] as $key => $domain) {
            $parts = explode('.', $domain['domain']);
            $tld = end($parts);
            unset($parts[key($parts)]);

            $params = [
                'sld' => implode('.', $parts),
                'tld' => $tld,
            ];
            $result = $API->check($params);
        }

        if (1 == $result['failed']) {
            $values['error'] = $result['reason'];
        }

        return $values;
    } catch (Exception $e) {
        //echo 'Caught exception: ',  $e->getMessage(), "\n";
    }
}

function IsRegistrarEurodns($uID,$dID)
{
    $command = 'GetClientsDomains';
    $postData = [
        'clientid' => $uID,
        'stats' => true,
    ];

    $results = localAPI($command, $postData);

    foreach ($results['domains']['domain'] as $key => $domain) {
        if ($domain['id'] === $dID) {
            if ('EuroDNS' === $domain['registrar'] && class_exists('EuroDNS')) {
                return $domain;
            }
        }
    }

    return false;
}

add_hook('ShoppingCartValidateDomainsConfig', 1, 'eurodns_ShoppingCartValidateDomainsConfig');
add_hook('ClientAreaPageDomainDNSManagement', 10, function ($vars) {

    if (IsRegistrarEurodns($vars['userid'],$vars['domainid'])) 
    {
        $formUrl = $_SERVER['PHP_SELF'].'?action=domaindns';
        $DID = end(explode('=', $vars['breadcrumb'][3]['link']));
        $token = $vars['token'];
        $parts = explode('.', $vars['breadcrumb'][3]['label']);
        $tld = end($parts);
        unset($parts[key($parts)]);
        $API = new EuroDNS(getEuroDNSConfig());
        $res = $API->zoneInfo(['sld' => implode('.', $parts), 'tld' => $tld]);
        echo $API->GetDNSForm($res, $formUrl, $token, $DID);
    }
});

add_hook('ClientAreaHeaderOutput', 1, function ($vars) {

    //if(IsRegistrarEurodns($vars['userid'],$vars['domainid']))
    //{
        $domain = $vars['domain'];
        $data = getEuroDNSConfig();
        $tld = substr($domain, strpos($domain, '.') + 1);

        $parts = explode('.', $domain);
        $API = new EuroDNS($data);

        $API->getInfo(['sld' => $parts[0], 'tld' => $tld]);

        if (!empty($API->getPendingMessage())) {
            return '<style>
            #Primary_Sidebar-Domain_Details_Management-Auto_Renew_Settings, ul.dropdown-menu.text-left.dropdown-menu-right li:nth-child(3)
            {
                display:none !important;
            }
        </style>'.$API->GetInfoMessageFrontend('Pending Action: '.$domain, 'here is some pending actions from your registrar. The information that appears on the page might be not up to date. Current action: <strong>"'.$API->getPendingMessage().'"</strong>. Some actions like changing nameservers will maybe not performed.');
        }

        return '<style>
            #Primary_Sidebar-Domain_Details_Management-Auto_Renew_Settings, ul.dropdown-menu.text-left.dropdown-menu-right li:nth-child(3)
            {
                display:none !important;
            }
        </style>';
    //}
});

add_hook('DomainEdit', 1, function ($vars) {
    if($domain = IsRegistrarEurodns($vars['userid'],$vars['domainid']))
    {
        $data = getEuroDNSConfig();
        $API = new EuroDNS($data);
        $array = explode('.', $domain['domainname'], 2);
        $data['sld'] = $array[0];
        $data['tld'] = $array[1];
        $info = $API->getInfo($data);

        if ($info) {
            $autoRenew = strtolower((string) $info->xpath('/response/resData/domain:renewal')[0]);
            $whmcsRenew = ''.$domain['donotrenew'];
            if (('autoexpire' === $autoRenew && '0' === ''.$whmcsRenew) || ('autorenew' === $autoRenew && '1' === ''.$whmcsRenew)) {
                $data['renewal'] = ('1' === $whmcsRenew ? 'autoexpire' : 'autorenew');
                $API->SetRenewalMode($data);
                logModuleCall('EuroDNS', 'auto renew change', $API->getRequest(), $API->getResponse(), null, null);
            }
        }
    }
});

add_hook('ClientAreaDomainDetailsOutput', 1, function ($vars) {
    
    if(IsRegistrarEurodns($vars['userid'],$vars['domainid']))
    {
        $domain = $vars['domain'];
        $data = getEuroDNSConfig();
        $mydomain = $domain->domain;
        $tld = substr($mydomain, strpos($mydomain, '.') + 1);
        $API = new EuroDNS($data);

        if (!$mydomain || empty($tld)) {
            return;
        }

        $tldNeed = $API->getCachedInfo(['tld', $tld, 'lockingEnabled'], true);

        if (!$tldNeed && empty($tldNeed)) {
            $infoTLD = $API->infoTld($tld);
            $tldNeed = $infoTLD['lockingEnabled'];
        }

        if ('no' === strtolower($tldNeed)) {
            return '<style>
                .alert.alert-danger, #tabOverview a[href="#tabReglock"]
                {
                    display:none !important;
                }
            </style>';
        }
    }
});

add_hook('ClientAreaPrimarySidebar', 1, function (MenuItem $primarySidebar) {
    $data = getEuroDNSConfig();
    $domain = Menu::context('domain');
    $mydomain = $domain->domain;
    $tld = substr($mydomain, strpos($mydomain, '.') + 1);

    if (!$mydomain || empty($tld)) {
        return;
    }

    $API = new EuroDNS($data);
    //logModuleCall('EuroDNS','hook:ClientAreaPrimarySidebar', json_encode($mydomain),$tld,null,null);

    $tldNeed = $API->getCachedInfo(['tld', $tld, 'lockingEnabled'], true);

    if (!$tldNeed && empty($tldNeed)) {
        $infoTLD = $API->infoTld($tld);
        $tldNeed = $infoTLD['lockingEnabled'];
    }

    if ('no' === strtolower($tldNeed)) {
        if (!is_null($primarySidebar->getChild('Domain Details Management'))) {
            $primarySidebar->getChild('Domain Details Management')
                ->removeChild('Registrar Lock Status')
            ;
        }
    }
});

add_hook('ClientAreaPageDomainEPPCode', 1, function ($vars) {
    //var_dump($GLOBALS['EPP_CODE']);
});

//add_hook('InvoicePaid', 1, function($vars) {
//    logModuleCall('EuroDNS', 'invoice paid hook', json_encode($vars) , "DEBUG", null, null);
//});
